
TYPO3.Fluid - Bug # 6809

Status: Resolved Priority: Must have
Author: Peter Niederlag Category:
Created: 2010-03-12 Assigned To: Sebastian Kurfuerst
Updated: 2010-10-20 Due date:
Has patch:
Affected Flow version:
Subject: using f:link.action inside f:form breaks hmac verification
Description

It seems impossible to link to another Page/Controller/Action/Plugin with f:link.action inside a f:form.

Test-Template:

<f:form controller="Mycontroller" action="myaction" name="newObject" object="{newObject}">
    <!-- if we don't use a property of newObject the error is not triggered -->
    <f:form.textbox property="foo" />

    <f:form.submit name="mySubmit" value="Submit" />

    <!-- adding a link.action inside form with an Object triggers an "hmac could not be verified" error -->
    <!-- for some reason 'action' is dropped in RequestHashService->generateRequestHash() -->
    <!-- this happens only when we use a property of newObject -->
    <f:if condition="true">
            <f:link.action action="baz" pluginName="pi3" controller="foobar" pageUid="14">Link to somewhere else</f:link.action>
    </f:if>
</f:form>

Probably that's due to the fact that the Plugin (pix) seems not to be taken into account, when generating the hmac/Requesthash?

Related issues:
related to TYPO3.Fluid - Bug # 6514: HMAC error when rendering links inside f... Resolved 2010-02-18
related to TYPO3.Fluid - Bug # 6808: using f:link.action inside f:form breaks... Resolved 2010-03-12

History
#1 - 2010-03-12 13:49 - Peter Niederlag

This is probably related to the fact that Tx_Fluid_ViewHelpers_FormViewHelper uses '$this->controllerContext->getUriBuilder()->getLastArguments()'.

But now, since we a had another call on the UriBuilder in between (by using a f:link ViewHelper) this does not quite return the arguments as used on
f:form itself.

Now on, what would be a way to fix that?

#2 - 2010-03-12 14:14 - Peter Niederlag
- File fluidformViewHelper-hmacarguments-6809.diff added

and here is a patch. :->
#3 - 2010-03-15 16:52 - Sebastian Kurfuerst
- Status changed from New to Accepted
- Assigned To set to Sebastian Kurfuerst
- Priority changed from Should have to Must have

#4 - 2010-03-18 15:30 - Sebastian Kurfuerst
- Status changed from Accepted to Resolved
- % Done changed from 0 to 100
- Branch set to v4

Thanks for reporting, this issue has been solved because of Peter Niederlag's patch in r2049.

Greets, Sebastian

Files
fluidformViewHelper-hmacarguments-6809.diff 2.1 kB 2010-03-12 Peter Niederlag
